/* tfpwm.h, Uros Platise <uros.platise@ijs.si> */

#ifndef __TFPWM_H__
#define __TFPWM_H__

/* Table Length/3, Length/2 and total Length 
*/
#define SIN_TABLE_N3	50
#define SIN_TABLE_N2	75
#define SIN_TABLE_N		(SIN_TABLE_N2 * 2)

/* PWM Range:
	PWM_PERIOD = full_range - 1, 
    PWM_HPERIOD = full_range / 2
*/
#define PWM_PERIOD		199
#define PWM_HPERIOD		100


/* PWM Sync. semaphore. When zero, PWM variables are ready to accept new data 
   and tfpwm_set() function will execute immediatelly. */
extern unsigned char pwm_load_flag;


/* function protoypes */

/* Initializes PWMs and performs synchronous start of all PWMs */
void tfpwm_start(unsigned char sine_phase, unsigned char amplitude);

/* Stop all three PWMs */
void tfpwm_stop(void);

/* Set output phase of the sine wave, requires global interrupt enabled. */
void tfpwm_set(unsigned char sine_phase, unsigned char amplitude);

#endif
