	.module tfpwm.c
	.area lit(rom, con, rel)
_sin_table::
	.byte 0,2
	.byte 4,6
	.byte 8,10
	.byte 12,14
	.byte 16,18
	.byte 20,22
	.byte 24,26
	.byte 28,29
	.byte 31,33
	.byte 34,36
	.byte 37,39
	.byte 40,41
	.byte 42,43
	.byte 44,45
	.byte 46,47
	.byte 48,48
	.byte 49,49
	.byte 49,50
	.byte 50,50
	.byte 50,50
	.byte 50,49
	.byte 49,49
	.byte 48,48
	.byte 47,46
	.byte 45,44
	.byte 43,42
	.byte 41,40
	.byte 39,37
	.byte 36,34
	.byte 33,31
	.byte 29,28
	.byte 26,24
	.byte 22,20
	.byte 18,16
	.byte 14,12
	.byte 10,8
	.byte 6,4
	.byte 2
	.dbfile ./tfpwm.c
	.dbsym e sin_table _sin_table A[75:75]c
	.area data(ram, con, rel)
	.dbfile ./tfpwm.c
_pwm_load_flag::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./tfpwm.c
	.dbsym e pwm_load_flag _pwm_load_flag c
_debug_sync_out::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./tfpwm.c
	.dbsym e debug_sync_out _debug_sync_out c
	.area text(rom, con, rel)
	.dbfile ./tfpwm.c
	.dbfunc e sine_calcwidth _sine_calcwidth fc
;           tval -> X+0
;      amplitude -> X-5
;          phase -> X-4
_sine_calcwidth::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 51
; /* tfpwm.c
; 	Three Phase Sine Generator	
; 	Uros Platise (c) 2003, <uros.platise@ijs.si>
; */
; 
; #include <tfpwmapi.h>
; #include "tfpwm.h"
; 
; /* to provide debug sync. output so you may see the center-based pulses on the scope */
; //#define DEBUG
; 
; #define PSoC_Designer_V4
; 
; /* fix the diferences between the PSoC builder version 3 and 4 */
; #ifdef PSoC_Designer_V4
;   #define PWM8_1_PWIDTH_REG	PWM8_1_COMPARE_REG
;   #define PWM8_2_PWIDTH_REG	PWM8_2_COMPARE_REG
;   #define PWM8_3_PWIDTH_REG	PWM8_3_COMPARE_REG
; #endif
; 
; /* Table of Half-Wave Symetric Sinus Function */
; const char sin_table[SIN_TABLE_N2] = 
; {
; 	0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 22, 24, 26, 28, 
; 	29, 31, 33, 34, 36, 37, 39, 40, 41, 42, 43, 44, 45, 46, 
; 	47, 48, 48, 49, 49, 49, 50, 50, 50, 50, 50, 50, 49, 49, 
; 	49, 48, 48, 47, 46, 45, 44, 43, 42, 41, 40, 39, 37, 36, 
; 	34, 33, 31, 29, 28, 26, 24, 22, 20, 18, 16, 14, 12, 10, 
; 	8, 6, 4, 2
; };
; 
; 
; /* global variables for synchronous load */
; unsigned char pwm1, period1, pwm2, period2, pwm3, period3;
; 
; /* pwm width are delayed for one period */
; unsigned char bpwm1, bpwm2, bpwm3;
; 
; /* semaphore */
; unsigned char pwm_load_flag = 0;
; 
; /* test sync. output */
; unsigned char debug_sync_out = 0;
; 
; 
; /*
; 	Sine Retrieve function
; */
; 
; unsigned char sine_calcwidth(unsigned char phase, unsigned char amplitude)
; {
	.dbline 54
; 	unsigned char tval;
; 
; 	if (phase >= SIN_TABLE_N) phase -= SIN_TABLE_N;
	cmp [X-4],-106
	jz X0
	jc L2
X0:
	.dbline 54
	mov A,[X-4]
	sub A,-106
	mov [X-4],A
L2:
	.dbline 56
; 	
; 	if (phase < SIN_TABLE_N2)
	cmp [X-4],75
	jnc L4
X1:
	.dbline 57
; 	{
	.dbline 58
; 		tval = sin_table[phase];
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_sin_table
	adc [__r0],>_sin_table
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+0],A
	.dbline 59
; 		return PWM_HPERIOD + (tval << 1);	// make it even, add a zero on right side
	mov A,[X+0]
	mov [__r0],A
	asl [__r0]
	add [__r0],100
	mov A,[__r0]
	xjmp L1
L4:
	.dbline 62
; 	}
; 	else
; 	{
	.dbline 63
; 		tval = sin_table[phase - SIN_TABLE_N2];
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_sin_table-75
	adc [__r0],>_sin_table-75
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+0],A
	.dbline 64
; 		return PWM_HPERIOD - (tval << 1);	// make it even, add a zero on right side
	mov A,[X+0]
	mov [__r0],A
	asl [__r0]
	mov A,100
	sub A,[__r0]
	.dbline -2
L1:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l tval 0 c
	.dbsym l amplitude 0 I
	.dbsym l amplitude -5 c
	.dbsym l phase 0 I
	.dbsym l phase -4 c
	.dbend
	.area data(ram, con, rel)
	.dbfile ./tfpwm.c
L8:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./tfpwm.c
	.area text(rom, con, rel)
	.dbfile ./tfpwm.c
	.dbfunc e tfpwm_isr _tfpwm_isr fV
	.dbsym s irq_count L8 c
_tfpwm_isr::
	.dbline -1
	push A
	.dbline 104
; 	}
; }
; 
; 
; 
; 
; /* 
; 	Three Phase PWM Fast Interrupt
; 	
; 	Note: C-compiler compiles the following ISR so good, 
; 	as it were almost written in assembler. Minor optimizations
; 	may still be applied. Check the output .lst file for details.
; 	
; 	Placement of the PWM8 blocks _must_ be such that they are 
; 	assigned highest priority interrupts - all three!
; 	
; 	Approximate cycle analyzation:
; 	
; 	IRQ_COUNT	PWM_UPLOAD	CYCLES
; 	---------------------------------------	
; 	0			-			27+35+43 = 105
; 	1			-			27+43    = 70
; 	2			YES			27+73+43 = 143
; 	2			NO			27+24+43 = 94
; 	---------------------------------------
; 	WORST CASE TOTAL: 318 
; 	
; 	Details:
; 	---------------------------------------
; 	IRQ Entry: 27
; 	IRQ_Count_0: 35
; 	IRQ_Count_1: 0
; 	IRQ_Count_2: 24 / 73
; 	IRQ_Exit: 43
; */
; 
; #pragma interrupt_handler tfpwm_isr
; 
; void tfpwm_isr()
; {
	.dbline 107
; 	static unsigned char irq_count=0;
; 
; 	if (irq_count==0)
	cmp [L8],0
	jnz L9
	.dbline 108
; 	{				
	.dbline 109
; 		PWM8_1_PWIDTH_REG = bpwm1;
	mov A,[_bpwm1]
	mov REG[34],A
	.dbline 110
; 		PWM8_2_PWIDTH_REG = bpwm2;
	mov A,[_bpwm2]
	mov REG[38],A
	.dbline 111
; 		PWM8_3_PWIDTH_REG = bpwm3;
	mov A,[_bpwm3]
	mov REG[42],A
	.dbline 112
; 	}
	xjmp L10
L9:
	.dbline 113
; 	else if (irq_count==2)
	cmp [L8],2
	jnz L11
	.dbline 114
; 	{
	.dbline 115
; 		if (pwm_load_flag)
	cmp [_pwm_load_flag],0
	jz L13
	.dbline 116
; 		{
	.dbline 117
; 			PWM8_1_PERIOD_REG = period1;
	mov A,[_period1]
	mov REG[33],A
	.dbline 118
; 			PWM8_2_PERIOD_REG = period2;
	mov A,[_period2]
	mov REG[37],A
	.dbline 119
; 			PWM8_3_PERIOD_REG = period3;
	mov A,[_period3]
	mov REG[41],A
	.dbline 120
; 			bpwm1 = pwm1;
	mov [_bpwm1],[_pwm1]
	.dbline 121
; 			bpwm2 = pwm2;
	mov [_bpwm2],[_pwm2]
	.dbline 122
; 			bpwm3 = pwm3;
	mov [_bpwm3],[_pwm3]
	.dbline 126
; #ifdef DEBUG			
; 			PRT1DR = debug_sync_out;
; #endif
; 			pwm_load_flag = 0;
	mov [_pwm_load_flag],0
	.dbline 127
; 		}
	xjmp L14
L13:
	.dbline 129
; 		else
; 		{
	.dbline 131
; 			/* if load was unsuccessfull, next period has no change! */
; 			PWM8_1_PERIOD_REG = PWM_PERIOD;
	mov REG[33],-57
	.dbline 132
; 			PWM8_2_PERIOD_REG = PWM_PERIOD;
	mov REG[37],-57
	.dbline 133
; 			PWM8_3_PERIOD_REG = PWM_PERIOD;
	mov REG[41],-57
	.dbline 134
; 		}
L14:
	.dbline 135
; 	}	
L11:
L10:
	.dbline 137
	inc [L8]
	.dbline 138
	cmp [L8],3
	jnz L15
	.dbline 138
	mov [L8],0
L15:
	.dbline -2
	.dbline 142
; 	
; 	irq_count++;
; 	if (irq_count==3) irq_count=0;
; #ifdef DEBUG
; 	PRT1DR = 0;
; #endif
; }
L7:
	pop A
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e tfpwm_start _tfpwm_start fV
;      amplitude -> X-5
;     sine_phase -> X-4
_tfpwm_start::
	.dbline -1
	push X
	mov X,SP
	.dbline 151
; 
; 
; /*
; 	Three Phase API
; */
; 
; 
; void tfpwm_start(unsigned char sine_phase, unsigned char amplitude)
; {
	.dbline 152
; 	M8C_DisableGInt;
		and   F, FEh

	.dbline 155
; 
; 	/* Set comparator bus to low (default) to perform sync. start */
;     CMPPRG_1_Start(CMPPRG_1_LOWPOWER);
	push X
	mov A,1
	xcall _CMPPRG_1_Start
	.dbline 156
;     CMPPRG_1_SetRef(CMPPRG_1_REF1_000);
	mov A,-16
	xcall _CMPPRG_1_SetRef
	pop X
	.dbline 162
; 
; 	/* Set PWM start values / period and offset
; 	   Default counter value is updated while counter is stopped.
; 	*/
; 
; 	pwm1 = bpwm1 = sine_calcwidth(sine_phase, amplitude);
	mov A,[X-5]
	push A
	mov A,[X-4]
	push A
	xcall _sine_calcwidth
	add SP,-2
	mov [_bpwm1],A
	mov [_pwm1],[_bpwm1]
	.dbline 163
; 	PWM8_1_WritePeriod((bpwm1>>1)-1);
	mov [__r0],[_bpwm1]
	and F,-5
	rrc [__r0]
	sub [__r0],1
	push X
	mov A,[__r0]
	xcall _PWM8_1_WritePeriod
	.dbline 164
;     PWM8_1_Start();
	xcall _PWM8_1_Start
	.dbline 165
;     PWM8_1_WritePeriod(PWM_PERIOD);
	mov A,-57
	xcall _PWM8_1_WritePeriod
	.dbline 166
;     PWM8_1_WritePulseWidth(bpwm1);
	mov A,[_bpwm1]
	xcall _PWM8_1_WritePulseWidth
	.dbline 167
;     PWM8_1_EnableInt();
	xcall _PWM8_1_EnableInt
	pop X
	.dbline 169
; 
; 	pwm2 = bpwm2 = sine_calcwidth(sine_phase + SIN_TABLE_N3, amplitude);
	mov A,[X-5]
	push A
	mov A,[X-4]
	add A,50
	push A
	xcall _sine_calcwidth
	add SP,-2
	mov [_bpwm2],A
	mov [_pwm2],[_bpwm2]
	.dbline 170
; 	PWM8_2_WritePeriod((bpwm2>>1)-1);
	mov [__r0],[_bpwm2]
	and F,-5
	rrc [__r0]
	sub [__r0],1
	push X
	mov A,[__r0]
	xcall _PWM8_2_WritePeriod
	.dbline 171
;     PWM8_2_Start();
	xcall _PWM8_2_Start
	.dbline 172
;     PWM8_2_WritePeriod(PWM_PERIOD);
	mov A,-57
	xcall _PWM8_2_WritePeriod
	.dbline 173
;     PWM8_2_WritePulseWidth(bpwm2);
	mov A,[_bpwm2]
	xcall _PWM8_2_WritePulseWidth
	.dbline 174
;     PWM8_2_EnableInt();
	xcall _PWM8_2_EnableInt
	pop X
	.dbline 176
; 
; 	pwm3 = bpwm3 = sine_calcwidth(sine_phase + (2*SIN_TABLE_N3), amplitude);
	mov A,[X-5]
	push A
	mov A,[X-4]
	add A,100
	push A
	xcall _sine_calcwidth
	add SP,-2
	mov [_bpwm3],A
	mov [_pwm3],[_bpwm3]
	.dbline 177
; 	PWM8_3_WritePeriod((bpwm3>>1)-1);
	mov [__r0],[_bpwm3]
	and F,-5
	rrc [__r0]
	sub [__r0],1
	push X
	mov A,[__r0]
	xcall _PWM8_3_WritePeriod
	.dbline 178
;     PWM8_3_Start();
	xcall _PWM8_3_Start
	.dbline 179
;     PWM8_3_WritePeriod(PWM_PERIOD);
	mov A,-57
	xcall _PWM8_3_WritePeriod
	.dbline 180
;     PWM8_3_WritePulseWidth(bpwm3);
	mov A,[_bpwm3]
	xcall _PWM8_3_WritePulseWidth
	.dbline 181
;     PWM8_3_EnableInt();
	xcall _PWM8_3_EnableInt
	pop X
	.dbline 184
; 	
; 	/* new settings are ok */
; 	pwm_load_flag = 0;
	mov [_pwm_load_flag],0
	.dbline 187
; 	
; 	/* Run All - Sync. Start */
;     CMPPRG_1_SetRef(CMPPRG_1_REF0_062);
	push X
	mov A,0
	xcall _CMPPRG_1_SetRef
	pop X
	.dbline 188
;     M8C_EnableGInt;
		or    F, 01h

	.dbline -2
	.dbline 193
;     
;     /* After this point, comparator may be reused for other purposes ...
;        (do not forget to set pwm enable bits to high)
;     */
; }
L17:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l amplitude 0 I
	.dbsym l amplitude -5 c
	.dbsym l sine_phase 0 I
	.dbsym l sine_phase -4 c
	.dbend
	.dbfunc e tfpwm_stop _tfpwm_stop fV
_tfpwm_stop::
	.dbline -1
	.dbline 196
; 
; void tfpwm_stop(void)
; {
	.dbline 197
; 	PWM8_1_Stop();
	push X
	xcall _PWM8_1_Stop
	.dbline 198
; 	PWM8_1_DisableInt();
	xcall _PWM8_1_DisableInt
	.dbline 199
; 	PWM8_2_Stop();
	xcall _PWM8_2_Stop
	.dbline 200
; 	PWM8_2_DisableInt();
	xcall _PWM8_2_DisableInt
	.dbline 201
; 	PWM8_3_Stop();
	xcall _PWM8_3_Stop
	.dbline 202
; 	PWM8_3_DisableInt();
	xcall _PWM8_3_DisableInt
	pop X
	.dbline -2
	.dbline 203
; }
L18:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e tfpwm_set _tfpwm_set fV
;      amplitude -> X-5
;     sine_phase -> X-4
_tfpwm_set::
	.dbline -1
	push X
	mov X,SP
	.dbline 206
; 
; void tfpwm_set(unsigned char sine_phase, unsigned char amplitude)
; {
L20:
	.dbline 208
L21:
	.dbline 208
; 	/* wait until pwm isr loads new settings */
; 	while(pwm_load_flag);
	cmp [_pwm_load_flag],0
	jnz L20
	.dbline 215
; 
; #ifdef DEBUG
; 	if (sine_phase==0) debug_sync_out = 0x08; else debug_sync_out = 0x00;
; #endif
; 	
; 	/* calculate new values for the pwm */
; 	pwm1   >>= 1;
	and F,-5
	rrc [_pwm1]
	.dbline 216
; 	period1  = PWM_PERIOD - pwm1;
	mov A,-57
	sub A,[_pwm1]
	mov [_period1],A
	.dbline 217
; 	pwm1     = sine_calcwidth(sine_phase, amplitude);
	mov A,[X-5]
	push A
	mov A,[X-4]
	push A
	xcall _sine_calcwidth
	add SP,-2
	mov [_pwm1],A
	.dbline 218
; 	period1 += (pwm1 >> 1);
	mov [__r0],[_pwm1]
	and F,-5
	rrc [__r0]
	mov A,[__r0]
	add [_period1],A
	.dbline 220
; 
; 	pwm2   >>= 1;
	and F,-5
	rrc [_pwm2]
	.dbline 221
; 	period2  = PWM_PERIOD - pwm2;
	mov A,-57
	sub A,[_pwm2]
	mov [_period2],A
	.dbline 222
; 	pwm2     = sine_calcwidth(sine_phase + SIN_TABLE_N3, amplitude);
	mov A,[X-5]
	push A
	mov A,[X-4]
	add A,50
	push A
	xcall _sine_calcwidth
	mov [_pwm2],A
	.dbline 223
; 	period2 += (pwm2 >> 1);
	mov [__r0],[_pwm2]
	and F,-5
	rrc [__r0]
	mov A,[__r0]
	add [_period2],A
	.dbline 225
; 
; 	pwm3   >>= 1;
	and F,-5
	rrc [_pwm3]
	.dbline 226
; 	period3  = PWM_PERIOD - pwm3;
	mov A,-57
	sub A,[_pwm3]
	mov [_period3],A
	.dbline 227
; 	pwm3     = sine_calcwidth(sine_phase + (2*SIN_TABLE_N3), amplitude);
	mov A,[X-5]
	push A
	mov A,[X-4]
	add A,100
	push A
	xcall _sine_calcwidth
	add SP,-4
	mov [_pwm3],A
	.dbline 228
; 	period3 += (pwm3 >> 1);
	mov [__r0],[_pwm3]
	and F,-5
	rrc [__r0]
	mov A,[__r0]
	add [_period3],A
	.dbline 231
; 	
; 	/* request pwm update */
; 	pwm_load_flag = 1;
	mov [_pwm_load_flag],1
	.dbline -2
	.dbline 232
; }
L19:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l amplitude 0 I
	.dbsym l amplitude -5 c
	.dbsym l sine_phase 0 I
	.dbsym l sine_phase -4 c
	.dbend
	.area bss(ram, con, rel)
	.dbfile ./tfpwm.c
_bpwm3::
	.blkb 1
	.dbsym e bpwm3 _bpwm3 c
_bpwm2::
	.blkb 1
	.dbsym e bpwm2 _bpwm2 c
_bpwm1::
	.blkb 1
	.dbsym e bpwm1 _bpwm1 c
_period3::
	.blkb 1
	.dbsym e period3 _period3 c
_pwm3::
	.blkb 1
	.dbsym e pwm3 _pwm3 c
_period2::
	.blkb 1
	.dbsym e period2 _period2 c
_pwm2::
	.blkb 1
	.dbsym e pwm2 _pwm2 c
_period1::
	.blkb 1
	.dbsym e period1 _period1 c
_pwm1::
	.blkb 1
	.dbsym e pwm1 _pwm1 c
